static char *rcsid = "$Header: /navy/homes/zeus/SRC/RCS/turn.c,v 2.42 1994/05/17 13:43:15 bampton Exp bampton $";

#define NOTIMEB
#include "common.h"
#include "prot.h"
void turn_rcsid (void);

void
turn_rcsid (void)
{
  printf ("%s\n", rcsid);
}


/* Magic hack to get forcast code to work... */

#ifndef FORECAST

#ifdef PREPROC
#define NOPREPROC
#undef VERBOSE
#endif

#endif

#ifndef NOPREPROC
/*
 * $Log: turn.c,v $
 * Revision 2.42  1994/05/17  13:43:15  bampton
 * *** empty log message ***
 *
 * Revision 2.41  1994/04/08  03:11:28  bampton
 * *** empty log message ***
 *
 * Revision 2.40  1994/03/09  20:22:55  bampton
 * *** empty log message ***
 *
 * Revision 2.39  1993/10/28  22:31:20  bampton
 * Revision 2.38  1993/09/27  17:15:54  bampton
 * Revision 2.37  1993/09/07  20:50:32  bampton
 * Revision 2.34  1993/08/09  23:06:20  bampton
 * Revision 2.33  1993/08/03  23:10:13  bampton
 * Revision 2.30  1993/07/14  14:59:26  bampton
 * Revision 0.0  1993/07/14  13:42:30  bampton RCS prototype.
 */

double colinc (planet * p);
void sortphase (void);
void candnphase (void);
void fleetphase (void);

extern player *players;
extern planet *planets;
extern battle *battles;
extern bombing *bombings;
extern shiptype *shiptypes;
extern fleetname *fleets;
extern int turn;
extern int turn_run;
extern int nplanets;
extern tmppname *tmpname;

int seenlist[1000];             /* this is a hack, gotta be a better way to do it */

#ifdef FORECAST
void
build_seen_list (player * P)
{
  int x;
  planet *p;

  for (x = 0; x < nplanets; x++)
    seenlist[x] = 0;
  /* do something */
  for (p = planets, x = 1; p; p = p->next, x++)
  {
    seenlist[x] = canseeplanet (P, p);
    /*printf ("%d %d\n", x, seenlist[x]); */
  }
}
#endif
void
loadphase (void)
{
  player *P;
  group *g, *g2;
  int i;
  planet *p;
  double qty, shipspace, availspace;

  for (p = planets; p; p = p->next)
    if ((P = p->owner) != 0)
    {
      if (p->routes[CG_COL])
        for (g = P->groups; g; g = g->next)
        {

#ifdef UPGRADE
          if (g->where == p && g->type->cargo && g->dist == 0.0 &&
              g->type->drive > 0.01 && !g->fleet)
#else
          if (g->where == p && g->type->cargo && g->dist == 0.0 &&
              g->type->drive > 0.01)
#endif

          {
            if (g->loadtype == CG_EMPTY && p->col)
            {
              qty = p->col;
              shipspace = cargospace (g);
              availspace = g->ships * shipspace;
              if (qty > availspace)
                qty = availspace;
              p->col -= qty;
              availspace -= qty;
              i = availspace / shipspace;
              if (i)
              {
                g->ships -= i;
                g2 = alloc (sizeof (group));
                *g2 = *g;
                addlist (&P->groups, g2);
                g2->ships = i;
              }
              g->loadtype = CG_COL;
              g->load = qty / g->ships;
            }
            if (g->loadtype == CG_COL)
              send (g, p->routes[CG_COL]);
          }
        }
      if (p->routes[CG_CAP])
        for (g = P->groups; g; g = g->next)
        {
          if (g->where == p && g->type->cargo && g->dist == 0.0 &&
              g->type->drive > 0)
          {
            if (g->loadtype == CG_EMPTY && p->cap)
            {
              qty = p->cap;
              shipspace = cargospace (g);
              availspace = g->ships * shipspace;
              if (qty > availspace)
                qty = availspace;
              p->cap -= qty;
              availspace -= qty;
              i = availspace / shipspace;
              if (i)
              {
                g->ships -= i;
                g2 = alloc (sizeof (group));
                *g2 = *g;
                addlist (&P->groups, g2);
                g2->ships = i;
              }
              g->loadtype = CG_CAP;
              g->load = qty / g->ships;
            }
            if (g->loadtype == CG_CAP)
              send (g, p->routes[CG_CAP]);
          }
        }
      if (p->routes[CG_MAT])
        for (g = P->groups; g; g = g->next)
          if (g->where == p && g->type->cargo && g->dist == 0.0 &&
              g->type->drive > 0)
          {
            if (g->loadtype == CG_EMPTY && p->mat)
            {
              qty = p->mat;
              shipspace = cargospace (g);
              availspace = g->ships * shipspace;
              if (qty > availspace)
                qty = availspace;
              p->mat -= qty;
              availspace -= qty;
              i = availspace / shipspace;
              if (i)
              {
                g->ships -= i;
                g2 = alloc (sizeof (group));
                *g2 = *g;
                addlist (&P->groups, g2);
                g2->ships = i;
              }
              g->loadtype = CG_MAT;
              g->load = qty / g->ships;
            }
            if (g->loadtype == CG_MAT)
              send (g, p->routes[CG_MAT]);
          }
      if (p->routes[CG_EMPTY])
        for (g = P->groups; g; g = g->next)
        {
          if (g->where == p && g->type->cargo && g->dist == 0 &&
              g->loadtype == CG_EMPTY && g->type->drive > 0)
          {
            send (g, p->routes[CG_EMPTY]);
          }
        }
    }
}

#ifndef FORECAST
void
interceptphase (void)
{
  int i, j;
  double maxmass, maxdist, *v;
  player *P, *P2;
  group *g, *g2;
  planet *p, *p2;

  i = 1;
  for (p = planets; p; p = p->next)
    i++;
  v = alloc (i * sizeof (double));

  for (P = players; P; P = P->next)
  {
    for (g = P->groups; g; g = g->next)
    {
      if (g->dist == -1.0)      /* Bugfix to deal with upgrade, HJB */
      {
        maxdist = 2 * g->type->drive * g->tech.drive * DRIVEMAGIC / shipmass (g);
        p = g->from;
        memset (v, 0, i * sizeof (double));

        for (P2 = players; P2; P2 = P2->next)
          if (P2 != P)
            for (g2 = P2->groups; g2; g2 = g2->next)
              if (g2->from == p && g2->where != p &&
                  g2->dist == dist (p, g2->where) &&
                  dist (g->where, g2->where) < maxdist)
                v[ptonum (planets, g2->where)] +=
                  g2->ships * shipmass (g2);
        maxmass = 0;
        for (j = 1, p2 = planets; j != i; j++, p2 = p2->next)
          if ((v[j] > maxmass) && (canseeplanet (P, p2)))
          {
            maxmass = v[j];
            p = p2;
          }
        send (g, p);
      }
    }
  }
  free (v);
}
#endif

#ifdef UPGRADE
void
fleetphase (void)
{
  player *P;
  fleetname *fl;
  group *g;
  double shipspeed;
  int hasships;

  for (fl = fleets; fl; fl = fl->next)
  {
    hasships = 0;
    fl->fleetspeed = 1000000.0;
    P = fl->owner;
    for (g = P->groups; g; g = g->next)
    {
      if (g->fleet == fl)
      {
        hasships = 1;
        shipspeed = g->type->drive * g->tech.drive * DRIVEMAGIC / shipmass (g);
        if (shipspeed < fl->fleetspeed)
          fl->fleetspeed = shipspeed;
      }
    }
    if (!hasships)
      removelist (&fleets, fl);
  }
}
#endif

void
movephase (void)
{
  player *P;
  group *g;

  for (P = players; P; P = P->next)
    for (g = P->groups; g; g = g->next)
    {

#ifdef UPGRADE
      if (g->fleet)
        g->dist -= g->fleet->fleetspeed;
      else
#endif

        g->dist -= g->type->drive * g->tech.drive * DRIVEMAGIC / shipmass (g);
      if (g->dist < 0.0)
      {
        g->from = g->where;
        g->dist = 0.0;          /* This takes care of upgrade & overshoot
                                 * problems */
      }
    }
}

/* Unload iff, route goes from p to p2, and group is at p2 with cargo,
   and it isn't an alien planet[col only]
        OR
   autounload is set, we own the planet, and we've got ships there with
   cargo */

void
unloadphase (void)
{
  planet *p, *p2;
  group *g;
  register int i;

#ifdef FORECAST
  player *PP;

  for (PP = players; PP; PP = PP->next)
    if (PP->lastorders > turn)
      break;
#endif

  for (p = planets; p; p = p->next)
    if (p->owner)
      for (i = 0; i < CG_EMPTY; i++)
      {
        p2 = p->routes[i];
        for (g = p->owner->groups; g; g = g->next)
        {

#ifdef FORECAST
          if (p->owner == PP)
#endif

            if ((g->where == p2 && g->dist == 0.0 && g->loadtype == i &&
                 g->ships &&  /* To deal with routes to alien systems: */
                 !(g->loadtype == CG_COL && g->where->owner &&  
                   g->where->owner != p->owner && p->owner)    
                 && p2->size > ALMOSTZERO)
            /* GE: change: cannot unload onto size 0 systems */
                ||
                ((p->owner->opts2 & AUTOUNLOAD) && (g->where == p) &&
                 (g->dist == 0.0) && (g->ships) && g->loadtype != CG_EMPTY))
            {
              unloadgroup (g, p->owner);
            }                   /* end of: if gp at planet, planet >0, etc */
        }
      }                         /* end of: for loop over groups */
}

double
colinc (planet * p)
{
  double ind, popinc, extrapop, colinc, matdemand, inddemand;

  ind = effective_ind (p);
  /* ind = p->ind * .9 + p->pop * .1; */
  popinc = p->pop * POPINC;
  extrapop = p->size - p->pop;
  if (extrapop > popinc)
    extrapop = popinc;
  p->pop += extrapop;
  ind += min (p->pop - p->ind,
              p->cap * INDFROMCAP);     /* include new CAP->new IND */
  popinc -= extrapop;
  colinc = popinc / POPPERCOL;
  matdemand = colinc * MATPERCOL;
  if (matdemand > p->mat)
    matdemand = p->mat;
  if (matdemand > ind * MATPERCOL / INDPERCOL)
    matdemand = ind * MATPERCOL / INDPERCOL;
  colinc -= matdemand / MATPERCOL;
  p->col += matdemand / MATPERCOL;
  p->mat -= matdemand;
  ind -= matdemand / MATPERCOL * INDPERCOL;
  matdemand = colinc * MATPERCOL;
  if (p->resources > 0)
    inddemand = matdemand * (INDPERCOL / MATPERCOL + 1 / p->resources);
  else
    inddemand = matdemand * (INDPERCOL / MATPERCOL + 1 / ALMOSTZERO);

  if (inddemand > ind)
  {
    matdemand *= ind / inddemand;
    inddemand = ind;
  }
  ind -= inddemand;
  p->col += matdemand / MATPERCOL;
  ind += p->inprogress;

  assert ((ind - p->spent) > -0.001);   /* catch round off error */
  ind -= p->spent;
  if (ind < 0.0)
    ind = 0.0;                  /* make sure we have no round off error! */
  p->spent = 0.0;

  p->inprogress = 0.0;
  return ind;
}

void
producephase (void)
{
  planet *p;
  double ind, shipcost, matdemand, totcost;
  shiptype *T;
  player *P;
  int inships;
  group *g;

  for (p = planets; p; p = p->next)
    if (p->owner && p->producing == PR_SHIP)
    {
      ind = colinc (p);
      T = p->producingshiptype;
      shipcost = typemass (T);
      totcost = shipcost * INDPERSHIP;
      if (shipcost > p->mat)
      {
        totcost += ((shipcost - p->mat) / p->resources);
      }
      inships = 0;
      while (ind + ROUNDOFF >= totcost)
      {
        inships++;
        ind -= totcost;
        p->mat -= shipcost;
        if (p->mat < 0.0)
          p->mat = 0.0;
        totcost = shipcost * INDPERSHIP;
        if (shipcost > p->mat)
        {
          totcost = shipcost * INDPERSHIP +
            ((shipcost - p->mat) / p->resources);
        }
      }

      g = alloc (sizeof (group));
      g->ships = inships;
      p->inprogress = ind;
      g->type = T;
      g->tech = p->owner->tech;

#ifdef NEW1
      if (p->drive != 0)
        g->drive = p->drive;
      if (p->guns != 0)
        g->guns = p->guns;
      if (p->shields != 0)
        g->shields = p->shields;
      if (p->cargo != 0)
        g->cargo = p->cargo;
#endif

      if (!g->type->drive)
        g->tech.drive = 0.0;
      if (!g->type->nguns)
        g->tech.guns = 0.0;
      if (!g->type->shields)
        g->tech.shields = 0.0;
      if (!g->type->cargo)
        g->tech.cargo = 0.0;
      g->load = 0.0;
      g->loadtype = CG_EMPTY;
      g->from = g->where = p;
      g->dist = 0.0;

#ifdef UPGRADE
      T->numbuilt += inships;
      g->fleet = NULL;
#endif

      addlist (&p->owner->groups, g);
    }
  for (p = planets; p; p = p->next)
    if (p->owner && p->producing != PR_SHIP)
    {
      ind = colinc (p);
      P = p->owner;
      switch (p->producing)
      {
      case PR_CAP:
        matdemand = ind / INDPERCAP;
        if (matdemand > p->mat)
          matdemand = p->mat;
        ind -= matdemand * INDPERCAP;
        p->cap += matdemand;    /* ? */
        p->mat -= matdemand;
        if (p->resources > 0)
          matdemand = ind / (INDPERCAP + 1 / p->resources);
        else
          matdemand = ind / (INDPERCAP + 1 / ALMOSTZERO);
        p->cap += matdemand;
        break;
      case PR_MAT:
        p->mat += ind * p->resources;
        break;
      case PR_DRIVE:
        P->tech.drive += ind / INDPERRESEARCH;
        break;
      case PR_GUNS:
        P->tech.guns += ind / INDPERRESEARCH;
        break;
      case PR_SHIELDS:
        P->tech.shields += ind / INDPERRESEARCH;
        break;
      case PR_CARGO:
        P->tech.cargo += ind / INDPERRESEARCH;
        break;
      default:
        assert (0);
      }
    }
  for (p = planets; p; p = p->next)
  {
    double indinc = p->pop - p->ind;

    if (indinc > (p->cap * INDFROMCAP))
      indinc = (p->cap * INDFROMCAP);
    /* cap mod */
    p->cap -= indinc / INDFROMCAP;
    p->ind += indinc;
  }
}

void
joinphase (void)
{
  player *P;
  group *g, *g2, *g3;

  for (P = players; P; P = P->next)
    for (g = P->groups; g;)
      if (!g->ships)
      {
        g2 = g->next;
        removelist (&P->groups, g);
        g = g2;
      }
      else
      {
        for (g2 = P->groups; g2;)
          if (g != g2 &&

#ifdef UPGRADE
              g->fleet == g2->fleet &&
#endif

              g->type == g2->type &&
              g->tech.drive == g2->tech.drive &&
              g->tech.guns == g2->tech.guns &&
              g->tech.shields == g2->tech.shields &&
              g->tech.cargo == g2->tech.cargo &&
              g->loadtype == g2->loadtype &&
              g->load == g2->load &&
              g->from == g2->from &&    /* Bugfix per k.pankhurst@ic.ac.uk */
              g->where == g2->where &&
              g->dist == g2->dist)
          {
            g->ships += g2->ships;
            g3 = g2->next;
            removelist (&P->groups, g2);
            g2 = g3;
          }
          else
            g2 = g2->next;
        g = g->next;
      }
}

void
sortphase (void)
{
  group *g, *g2, *newgroup;
  player *P;
  planet *Pl;
  int first;
  int HasBeenSorted;

#ifdef UPGRADE
  fleetname *fl;

#endif

  first = 1;
  HasBeenSorted = 0;
  for (P = players; P; P = P->next)
  {
    if ((P->opts2 & SORTGROUPS))
    {
      for (Pl = planets; Pl; Pl = Pl->next)
      {
        for (g = P->groups; g; g = g->next)
        {

#ifdef UPGRADE
          if ((g->where == Pl) && (!g->fleet))
#else
          if (g->where == Pl)
#endif

          {
            if (first)
            {
              first = 0;
              newgroup = alloc (sizeof (group));
              *newgroup = *g;
              HasBeenSorted = 1;
              newgroup->next = 0;
            }
            else
            {
              g2 = alloc (sizeof (group));
              *g2 = *g;
              addlist (newgroup, g2);
            }
          }
        }

#ifdef UPGRADE
        for (fl = fleets; fl; fl = fl->next)
          if (fl->owner == P)
          {
            for (g = P->groups; g; g = g->next)
              if ((g->where == Pl) && (g->fleet == fl))
              {
                if (first)
                {
                  first = 0;
                  newgroup = alloc (sizeof (group));
                  *newgroup = *g;
                  HasBeenSorted = 1;
                  newgroup->next = 0;
                }
                else
                {
                  g2 = alloc (sizeof (group));
                  *g2 = *g;
                  addlist (newgroup, g2);
                }
              }
          }
#endif

      }
      if (HasBeenSorted)
      {
        HasBeenSorted = 0;
        P->groups = newgroup;
      }
      first = 1;
    }
  }
}

void
candnphase (void)
{
  tmppname *pname;
  player *P;

  for (pname = tmpname; pname; pname = pname->next)
  {
    P = nametop (players, pname->oname);
    if (P)
      strcpy (P->name, pname->nname);
  }
  freelist (tmpname);
  tmpname = NULL;
}

void
go (void)
{

#ifndef FORECAST
  battle *B;
  bombing *b;

#endif
  player *P;
  group *g;

#ifdef VERBOSE
  printf ("Running turn\nHouse cleaning\n");
#endif

#ifndef FORECAST
  turn_run = 1;

  for (B = battles; B; B = B->next)
  {
    freelist (B->shots);
    freelist (B->viewers);
  }
  freelist (battles);
  battles = NULL;

  for (b = bombings; b; b = b->next)
    freelist (b->viewers);
  freelist (bombings);
  bombings = NULL;

  {
    player *P2;

    for (P = players; P;)       /* delete dead players, if needed */
    {
      P2 = P->next;
      delete_player (P, 0);
      P = P2;
    }
  }
#endif

  /* Bugfix to deal with upgrade side effects */
  for (P = players; P; P = P->next)
    for (g = P->groups; g; g = g->next)
    {
      if (g->dist < -1.0)
        g->dist = 0.0;
    }
  joinphase ();

#ifndef FORECAST

#ifdef VERBOSE
  printf ("First battle phase\n");
#endif

  fightphase ();
  bombphase ();
#endif

#ifdef VERBOSE
  printf ("Routes, intercepts, movement, merging\n");
#endif

  loadphase ();

#ifdef UPGRADE
  fleetphase ();
#endif

#ifndef FORECAST
  interceptphase ();
#endif

  movephase ();
  joinphase ();

#ifndef FORECAST

#ifdef VERBOSE
  printf ("Second battle phase\n");
#endif

  fightphase ();
  bombphase ();
#endif

#ifdef VERBOSE
  printf ("Route unloading, production, merging, sorting planets/groups\n");
#endif

  unloadphase ();
  producephase ();
  joinphase ();

  sortplanets ();               /* GE: compile list of planets for reports */
  sortphase ();                 /* sort groups, if need be */

#ifdef UPGRADE
  fleetphase ();
#endif

  candnphase ();
  turn++;

#ifdef VERBOSE
  printf ("Done with turn\n");
#endif

#ifndef PREPROC
  {
    player *P;

    printf ("Checking for inactive players...\n");
    for (P = players; P; P = P->next)
    {
      if (P->lastorders + 1 < turn)
        printf ("%s last had orders for turn %d\n", P->name, P->lastorders);
    }
  }
#endif
}
#endif
